package com.product.kt.test.service;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import com.product.core.dao.BaseDao;
import com.product.core.entity.DataTableEntity;
import com.product.core.entity.FieldSetEntity;
import com.product.datasource.dao.Dao;
import com.product.datasource.entity.DataBaseEntity;
import com.product.util.BaseUtil;

/**
 * 	读取数据工具类
 * @author 86151
 *
 */
@Component
public class ReadToolsService {

	@Autowired
	BaseDao baseDao;
	
	//目标数据源
	private static final String dataSource="50114e37-3b78-4f60-841a-63ed72ae6820";
	
	//目标数据表
	private static final String tableName="product_sys_data_center_log";
	
	/**
	 * 	获取总条数
	 * @param a
	 * @param b
	 * @return
	 */
	public int getToolCount(){
		//获取数据同步配置
		FieldSetEntity sourceDataSourceFse = baseDao.getFieldSetEntity("product_sys_data_sync_manager", dataSource, false);
        DataBaseEntity sourceDbe = new DataBaseEntity(sourceDataSourceFse);
        Dao sourceDao = sourceDbe.getDao();
        //获取数据
        DataTableEntity dt = sourceDao.getList(tableName, "");
        if (!BaseUtil.dataTableIsEmpty(dt)) {
        	return dt.getRows();
		}
        return 0;
	}
	
	
	/**
	 * 	获取数据
	 * @param a
	 * @param b
	 * @return
	 */
	public List<FieldSetEntity> getToolListByAutoId(int a, int b){
		//获取数据同步配置
		FieldSetEntity sourceDataSourceFse = baseDao.getFieldSetEntity("product_sys_data_sync_manager", dataSource, false);
        DataBaseEntity sourceDbe = new DataBaseEntity(sourceDataSourceFse);
        Dao sourceDao = sourceDbe.getDao();
        //获取数据
        DataTableEntity dt = sourceDao.getList(tableName, "", new Object[] {}, a, b);
        return dt.getData();
	}
}
